qitmask.h File Reference

Provides optimised "base 4 bitmasks" of fixed length. More...

`#include <algorithm>`
`#include <iostream>`
`#include "regina-core.h"`
`#include "regina-config.h"`

## Classes

class | regina::Qitmask1< T >
| A small but extremely fast "base 4 bitmask" class that can store up to 8 * sizeof(T) "qits", each equal to 0, 1, 2 or 3. More...
class | regina::Qitmask1< T >
| A small but extremely fast "base 4 bitmask" class that can store up to 8 * sizeof(T) "qits", each equal to 0, 1, 2 or 3. More...
class | regina::Qitmask2< T, U >
| A small but extremely fast "base 4 bitmask" class that can store up to 8 * sizeof(T) + 8 * sizeof(U) "qits", each equal to 0, 1, 2 or 3. More...
class | regina::Qitmask2< T, U >
| A small but extremely fast "base 4 bitmask" class that can store up to 8 * sizeof(T) + 8 * sizeof(U) "qits", each equal to 0, 1, 2 or 3. More...

## Namespaces

| regina
| Contains the entire Regina calculation engine.

## Typedefs

typedef Qitmask1< unsigned char > | regina::QitmaskLen8
| A convenience typedef that gives a small and extremely fast qitmask class capable of holding at least 8 true-or-false bits. More...
typedef Qitmask1< unsigned int > | regina::QitmaskLen16
| A convenience typedef that gives a small and extremely fast qitmask class capable of holding at least 16 true-or-false bits. More...
typedef InternalQitmaskLen32 ::Type | regina::QitmaskLen32
| A convenience typedef that gives a small and extremely fast qitmask class capable of holding at least 32 true-or-false bits. More...
typedef InternalQitmaskLen64 ::Type | regina::QitmaskLen64
| A convenience typedef that gives a small and extremely fast qitmask class capable of holding at least 64 true-or-false bits. More...

## Functions

template<typename T >
std::ostream & | regina::operator<< (std::ostream &out, const Qitmask1< T > &mask)
| Writes the given qitmask to the given output stream as a sequence of digits (0, 1, 2 and/or 3). More...
template<typename T , typename U >
std::ostream & | regina::operator<< (std::ostream &out, const Qitmask2< T, U > &mask)
| Writes the given qitmask to the given output stream as a sequence of digits (0, 1, 2 and/or 3). More...

## Detailed Description

Provides optimised "base 4 bitmasks" of fixed length.

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).